# AStern-Labyrinth-mit-Ausgaben.py

# ----- A*-Graph -----
# Es werden in einem Dictionary die gesperrten Felder angegeben.
gesperrt={
    1:[2,6],
    2:[2,3,4,6,8,9],
    3:[2,6,8,9],
    4:[6,9],
    5:[],
    6:[3,4,5,6],
    7:[3,7],
    8:[3,7],
    9:[],
    10:[]
}

# ----- Alternative als Liste -----
##gesperrt=[[], ## dummy um den Startindex 1 zu erzielen
##          [2,6],
##          [2,3,4,6,8,9],
##          [2,6,8,9],
##          [6,9],
##          [],
##          [3,4,5,6],
##          [3,7],
##          [3,7],
##          [],
##          []
##          ]

# ----- unzulaessig -----
# gibt von einem Feld an, ob es zulässig ist.
def zulaessig(feld):
    for koordinate in feld:
        if koordinate<1: return False
        if koordinate>10: return False
    if feld[1] in gesperrt[feld[0]]: return False
    return True

# ----- nachfolger -----
# bestimmt die zulässigen Nachfolgefelder eines Felds
def nachfolger(feld):
    ergebnis=[]
    for fall in [[-1,0],[1,0],[0,-1],[0,1]]:
        if zulaessig([feld[0]+fall[0],feld[1]+fall[1]]):
            ergebnis+=[[feld[0]+fall[0],feld[1]+fall[1]]]
    return ergebnis

# ----- restkosten -----
# Bestimmt zu einem Feld seine geschätzten Restkosten
# nach der Manhattan-Distanz.
def restkosten(feld):
    return abs(feld[0]-ziel[0])+abs(feld[1]-ziel[1])

# ----- kosten -----
# Bestimmt zu einem Weg seine Kosten.
def kosten(weg):
    return len(weg)-1

# ----- gesamtKosten -----
# bestimmt die Gesamtkosten.
def gesamtKosten(weg):
    return kosten(weg)+restkosten(weg[len(weg)-1])

# ----- prioWS -----
# Funktionen zur Verwaltung der Prioritaetswarteschlange

# ----- kuerzer -----
# Hier muss das Vergleichsprädikat kuerzer neu definiert werden.
def kuerzer(weg1, weg2):
    return gesamtKosten(weg1)<gesamtKosten(weg2)

# ----- expandiere -----
# Außerdem muss die Expansionsfunktion neu definiert werden.
# Damit keine Zyklen entstehen, müssen die Fortsetzungen gefiltert werden.
def expandiere(weg):
    fortsetzungen=nachfolger(weg[len(weg)-1])
    gefiltert=[]
    for knoten in fortsetzungen:
        if not knoten in weg:
            gefiltert.append(knoten)
    fortsetzungen=[]
    for i in range(len(gefiltert)):
        fortsetzungen.append(weg+[gefiltert[i]])
    return fortsetzungen
    

# ----- ordneEin -----
# Die Funktion ordnet einen einzelnen Weg ein.
def ordneEin(weg, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(weg, sortierte[index]):
            sortierte[index:index]=[weg]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[weg]
    return sortierte

# ----- ordneAlleEin -----
# Die Funktion ordnet eine Liste von wegn ein.
# [sortiert durch Einfügen]
def ordneAlleEin(wege, sortierte):
    for weg in wege:
        sortierte=ordneEin(weg, sortierte)
    return sortierte

# ----- expansionsSchritt -----
# nimmt das erste Element aus der Prioritätswarteschlange
# expandiert es und fügt die entstandenen Wege ein.
def expansionsSchritt(prioWS, ziel, breite=10,hoehe=10):
    wegZumZiel=None
    while wegZumZiel==None:
        prioWS=ordneAlleEin(expandiere(prioWS[0]), prioWS[1:])
        wegZumZiel=amZiel(prioWS, ziel)
        zeigeFeldUndWeg(breite,hoehe,prioWS[0])
        if input('weiter? / Abbruch q: ')=='q': return prioWS[0]
    return wegZumZiel

def amZiel(prioWS, ziel):
    for weg in prioWS:
        if ziel in weg:
            return weg
    return None

### ===== zeigeFeldUndWeg =================================
def zeigeFeldUndWeg(breite,hoehe,weg):
    print("\nFeld und Weg\n")
    for i in range(1,breite+1):
        zeile="  "
        for j in range(1,hoehe+1):
            if j in gesperrt[i]: zeile+="X "
            elif [i,j] in weg: zeile+="o "
            else: zeile+=". "
        print(zeile)
    print('(geschätzte) Gesamtkosten:',gesamtKosten(weg))
    print()

# ----- aStern -----
def aStern(start, ziel):
    return expansionsSchritt([[start]], ziel)

start,ziel=[9,6],[1,4]
##print( aStern(start, ziel) )

zeigeFeldUndWeg(10,10,aStern(start, ziel))


